/// <reference types="react" />
import { DatasourceStateError } from "@nexcodepl/endpoint-client";
import { StaticRouteBase } from "@nexcodepl/vite-static";
import { RouteDataContextProviderType } from "./routeDataContext.js";
interface Props<TStaticRoute extends StaticRouteBase<any, any>, TGlobalData> {
    RouteDataContextProvider: RouteDataContextProviderType;
    route: TStaticRoute;
    element: JSX.Element;
    wrapper: React.FC<{
        route: TStaticRoute;
        children: JSX.Element;
    }>;
    loader: JSX.Element;
    error: (error: DatasourceStateError) => JSX.Element;
    routes: TStaticRoute[];
    globalData: TGlobalData;
}
export declare function StaticDataProvider<TStaticRoute extends StaticRouteBase<any, any>, TGlobalData>({ route, element, loader, error, routes, globalData, wrapper, RouteDataContextProvider, }: Props<TStaticRoute, TGlobalData>): JSX.Element;
export {};
